=== debian/changelog ===
dsda-doom (0.25.6+dfsg-1) unstable; urgency=medium

  * New upstream version 0.25.6+dfsg.
  * Remove patch, applied upstream.

 -- Fabian Greffrath <fabian@debian.org>  Tue, 31 Jan 2023 07:51:06 +0100

dsda-doom (0.25.2+dfsg-2) unstable; urgency=medium

  * Add post-release fix for MS GS Synth bug.
  * Add symlinks for dsda-heretic and dsda-hexen.
  * Register symlinked executables as alternatives for Heretic and
    Hexen.

 -- Fabian Greffrath <fabian@debian.org>  Tue, 10 Jan 2023 09:05:40 +0100

dsda-doom (0.25.2+dfsg-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit,
    Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ Fabian Greffrath ]
  * Initial release. (Closes: #1026791)
  * New upstream version 0.25.2+dfsg
    + Exclude sound and soundfont lumps of spurious origin from the
      source tarball.
    + Drop epoch inherited from the src:prboom-plus package.
  * Update debian/changelog for added copyright holders and removed
    files.
  * Remove superfluous Build-Depends on libasound2-dev, libpcre3-dev
    and libpng-dev.
  * Turn prboom-plus and prboom-plus-game-server into transitional
    dummy packages.
    + As dsda-doom has abandoned network gaming, let
      prboom-plus-game-server suggest woof-doom for a Boom-compatible
      Doom source port with network gaming support.
    + Unconditionally remove doom and boom alternatives from the
      prboom-plus package.
    + Bump epoch to 3.
  * Add doom, boom, heretic and hexen alternatives for the dsda-doom
    package.
  * Bring back the manpage and bash completion file that were removed
    upstream.
  * Install the data file into /usr/share/dsda-doom.
  * Resize the icon at package build time using imagemagick
    (intermediate solution).

 -- Fabian Greffrath <fabian@debian.org>  Sat, 31 Dec 2022 13:28:13 +0100

prboom-plus (2:2.6.2-1) unstable; urgency=medium

  * New upstream version 2.6.2
  * Remove all patches, backported from upstream.

 -- Fabian Greffrath <fabian@debian.org>  Thu, 17 Feb 2022 08:29:59 +0100

prboom-plus (2:2.6.1um-1) unstable; urgency=medium

  * Fix debian/watch file.
  * New upstream version 2.6.1um
    + Implemented custom atexit() sequence, fixing crashes during
      shutdown e.g. when using Wayland (Closes: #988016).
  * Add some post-release patches from upstream to fix some minor
    issues with the build system.
  * Install binaries into /usr/games,
  * Significantly simplify packaging.
  * Bump Standards-Version to 4.5.1.
  * Add "Build-Depends: libasound2-dev [linux-any]" for the new ALSA
    music backend.
  * Bump "Build-Depends: libsdl2-dev" to (>= 2.0.7) as required by the
    build system.

 -- Fabian Greffrath <fabian@debian.org>  Thu, 19 Aug 2021 21:10:45 +0200

prboom-plus (2:2.6um-1) unstable; urgency=medium

  * New upstream version 2.6um
  * Do not install glboom-plus anymore, it has been superseded by
    plain prboom-plus.
  * Install prboom2/NEWS as upstream changelog.

 -- Fabian Greffrath <fabian@debian.org>  Tue, 09 Feb 2021 13:56:30 +0100

prboom-plus (2:2.5.1.7um+git127-1) unstable; urgency=medium

  * New upstream version 2.5.1.7um+git127
  * Adapt documentation install paths to upstream changes.

 -- Fabian Greffrath <fabian@debian.org>  Fri, 01 Jan 2021 17:22:15 +0100

prboom-plus (2:2.5.1.7um+git102-1) unstable; urgency=medium

  * New upstream version 2.5.1.7um+git102
  * Adapt documentation install paths to upstream changes.

 -- Fabian Greffrath <fabian@debian.org>  Tue, 03 Nov 2020 21:14:08 +0100

prboom-plus (2:2.5.1.7um+git89-1) unstable; urgency=medium

  * New upstream version 2.5.1.7um+git89
  * Remove config-debian.patch, all changes have been addressed
    upstream.
  * Replace all Suggests with ffmpeg, upstream has switched to an
    ffmpeg-based viddump approach.
  * Adapt packaging to upstream install rule.
  * Add usr/bin/prboom-plus to debian/not-installed, we install
    usr/bin/glboom-plus instead of prboom-plus.

 -- Fabian Greffrath <fabian@debian.org>  Fri, 26 Jun 2020 09:37:17 +0200

prboom-plus (2:2.5.1.7um+git82-1) unstable; urgency=medium

  * New upstream version 2.5.1.7um+git82 from commit fa28d882.
    + Fix heap buffer overflows in UDP code (CVE-2019-20797),
      Closes: #961031.
    + Fix compilation on big-endian architectures,
      Closes: #961336.
  * Refresh config-debian.patch, the game speed changing keys
    have been unbound upstream.

 -- Fabian Greffrath <fabian@debian.org>  Sat, 06 Jun 2020 15:09:36 +0200

prboom-plus (2:2.5.1.7um+git72-1) unstable; urgency=medium

  * Switch code base to the PrBoom+/UMAPINFO fork.
  * Adapt debian/watch file accordingly.
  * New upstream version 2.5.1.7um+git72 from commit e714a5bc.
  * Adapt debian/copyright accordingly.
  * Remove debian/gbp.conf.
  * Change default music backend back to SDL. OPL2 emulation is CPU
    expensive and MIDI rendering works with a default soundfont in SDL
    nowadays.
  * Add cmake to Build-Depends, upstream has changed the build
    system.
  * Adapt debian/rules and install rules to the changed build system.
  * Run "wrap-and-sort -asb".
  * No need to repack sources anymore, upstream has replaced or
    entirely removed all dubious or non-free data lumps.
  * Bump debhelper-compat to 13.
  * Bump Standards-Version to 4.5.0.
  * Rules-Requires-Root: no.
  * Strip "as-needed" LDFLAGS from debian/rules.
  * Remove obsolete Breaks and Replaces relations.
  * Install glboom-plus as prboom-plus.

 -- Fabian Greffrath <fabian@debian.org>  Fri, 22 May 2020 16:33:38 +0200

prboom-plus (2:2.5.1.5+svn4540+dfsg1-2) unstable; urgency=medium

  * Remove myself from Uploaders.

 -- Jonathan Dowland <jmtd@debian.org>  Mon, 11 May 2020 10:14:12 +0100

prboom-plus (2:2.5.1.5+svn4540+dfsg1-1) unstable; urgency=medium

  * New upstream version 2.5.1.5+svn4540+dfsg1
  * Unbind the Game Speed Up/Down keys, users might accidentally
    hit them (Closes: #922611).

