=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ \
		--sourcedirectory=prboom2 \
		--with bash_completion

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_BINDIR=games \
		-DDSDAPWADDIR=/usr/share/dsda-doom

override_dh_installchangelogs:
	dh_installchangelogs -- patch_notes/v$(basename $(DEB_VERSION_UPSTREAM_REVISION))*

override_dh_gencontrol:
	dh_gencontrol -pprboom-plus             -- -v3:$(DEB_VERSION_UPSTREAM_REVISION)
	dh_gencontrol -pprboom-plus-game-server -- -v3:$(DEB_VERSION_UPSTREAM_REVISION)
	dh_gencontrol --remaining-packages

execute_after_dh_install:
	#TODO: Remove this paragraph and Build-Depends: imagemagick,
	#      once upstream ships icons in SVG format or in PNG format
	#      with reasonable dimensions
	mkdir -p debian/dsda-doom/usr/share/icons/hicolor/512x512/apps && \
	convert prboom2/ICONS/dsda-doom.png -resize 512x512\! \
	debian/dsda-doom/usr/share/icons/hicolor/512x512/apps/dsda-doom.png
